# -*- coding: utf-8 -*-
# by einfall for DreamOS

from threading import Thread
import re, os, requests, json, time, urllib, urllib2, threading
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config, getConfigListEntry, ConfigSelection, ConfigText, ConfigClock, ConfigSubsection, ConfigYesNo, ConfigSubDict, ConfigNothing, ConfigInteger, configfile

config.plugins.alexatts = ConfigSubsection()

def writelog(msg):
	f = open('/usr/lib/enigma2/python/Plugins/Extensions/alexatts/log','a')
	f.write(msg+'\n')
	f.close()

class alexatts(threading.Thread):

	def __init__(self, session):
		self.session = session
		self.s = requests.Session()
		self.alexatts_login = False
		self.real = {}
		self.lastdata = ""
		self.callback_infos = None
		self.start_time = 0
		self.end_time = 0
		self.path = "/usr/lib/enigma2/python/Plugins/Extensions/alexatts/"
		threading.Thread.__init__(self)

	def setCallback(self, callback_infos):
		self.callback_infos = callback_infos

	def msgCallback(self, txt):
		print "call 1:", txt
		if self.callback_infos:
			print "call 1 going..."
			self.callback_infos(txt)

	def status(self):
		return self.alexatts_login

	def login(self, a_user, a_pass):
		self.s = requests.Session()
		self.s.headers.update({
							'User-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:63.0) Gecko/20100101 Firefox/64.0',
							'Accept-Language': 'en-US,en;q=0.5',
							'Connection': 'keep-alive',
							'Upgrade-Insecure-Requests': '1',
							'DNT': '1'
							})

		print "[Alexatts] Connecting.."
		writelog('[Alexatts] Connecting..--------------------------------------------------------------------------------------------------------')
		self.msgCallback(['msg', 'Verbinde'])
		url = "http://alexa.amazon.de"
		ok = self.s.get(url)
		postdata = re.findall('name="(.*?)"\svalue="(.*?)"', str(ok.text))
		if postdata:
			self.real = {}
			count = 0
			for each in postdata:
				self.real.update({each[0]:each[1]})
				count += 1
				if count == 6:
					break
			writelog('[Alexatts] real: %s' % self.real)

			fake_login = self.s.post('https://www.amazon.de/ap/signin', data="", allow_redirects=True)
			print "[Alexatts] Fake Login:", fake_login.status_code
			writelog('[Alexatts] Fake Login: %s' % fake_login.status_code)

			ssid = self.s.cookies.get_dict()['session-id']
			writelog('[Alexatts] ssid: %s' % ssid)
			self.s.headers.update({'Referer': 'https://www.amazon.de/ap/signin/'+ssid})
			self.real.update({'email': a_user, 'password': a_pass})
			login = self.s.post('https://www.amazon.de/ap/signin', data=self.real, allow_redirects=True)
			print "[Alexatts] Real Login:", login.status_code
			writelog('[Alexatts] Real Login %s:' % login.status_code)
			writelog('[Alexatts] Real Login %s:' % login.text)
			if re.search('<img alt="CAPTCHA" src="https://opfcaptcha-prod', login.text):
				print "[Alexatts] DEBUG: Captcha Abfrage bei Amazon erforderlich."
				captcha = re.findall('<img alt="CAPTCHA" src="(https://opfcaptcha-prod.*?)"', login.text)
				if captcha:
					self.lastdata = str(login.text)
					captcha_url = str(captcha[0]).replace('&amp;','&')
					captcha = urllib2.unquote(captcha_url)
					print "[Alexatts]", captcha
					bild_raw = self.s.get(captcha)
					with open("/tmp/alexa_captcha.jpg", 'wb') as f:
						f.write(bild_raw.content)
					del f
				self.msgCallback(['aktion', 'Captcha Eingabe'])
				return
			else:
				self.msgCallback(['msg', 'Suche Alexa Geraete'])
				self.getDevice()
		else:
			self.msgCallback(['msg', 'Fehler auf der Webseite'])
			return

	def getDevice(self):
		device = self.s.get('https://alexa.amazon.de/api/devices-v2/device?cached=false')
		print "[Alexatts] DEBUG:", device.text
		writelog('[Alexatts] DEBUG: %s' % device.text)

		if device:
			print "[Alexatts] Get Device List:", device.status_code
			writelog('[Alexatts] Get Device List: %s' % device.status_code)
			try:
				devices = json.loads(str(device.text))
				devices_list = {}
				for device in devices['devices']:
					devices_list.update({device['accountName']:
						{'deviceType': device['deviceType'], 'serialNumber': device['serialNumber'], 'deviceOwnerCustomerId': device['deviceOwnerCustomerId']
						}})
				self.save_cookies(self.s.cookies.get_dict())	
				self.save_devices(devices_list)
				self.msgCallback(['msg', 'Login Erfolgreich'])
				self.say("Login Erfolgreich")
				self.alexatts_login = True
				return
			except ValueError, e:
				self.msgCallback(['msg', str(e)])
				return
		else:
			self.msgCallback(['msg', 'Keine Geräte gefunden !'])
			return

	def enterCaptcha(self, captcha, a_user, a_pass):
		ssid = self.s.cookies.get_dict()['session-id']
		writelog('[Alexatts] ssid: %s' % ssid)
		self.s.headers.update({'Referer': 'https://www.amazon.de/ap/signin/'+ssid})
		postdata = re.findall('name="(.*?)"\svalue="(.*?)"', self.lastdata)
		if postdata:
			self.real = {}
			count = 0
			for each in postdata:
				self.real.update({each[0]:each[1]})
				count += 1
				if count == 6:
					break
		self.real.update({'guess': captcha, 'use_image_captcha': 'true', 'showPasswordChecked': 'false'})
		self.real.update({'email': a_user, 'password': a_pass})
		#writelog('[Alexatts] REAL POST: %s' % self.real)
		login = self.s.post('https://www.amazon.de/ap/signin', data=self.real, allow_redirects=True)
		print "[Alexatts] Real Login:", login.status_code
		writelog('[Alexatts] Real Login %s:' % login.status_code)
		writelog('[Alexatts] Real Login %s:' % login.text)
		if re.search('<img alt="CAPTCHA" src="https://opfcaptcha-prod', login.text):
			print "[Alexatts] DEBUG: Captcha Abfrage bei Amazon erforderlich."
			captcha = re.findall('<img alt="CAPTCHA" src="(https://opfcaptcha-prod.*?)"', login.text)
			if captcha:
				self.lastdata = str(login.text)
				captcha_url = str(captcha[0]).replace('&amp;','&')
				captcha = urllib2.unquote(captcha_url)
				print "[Alexatts]", captcha
				bild_raw = self.s.get(captcha)
				with open("/tmp/alexa_captcha.jpg", 'wb') as f:
					f.write(bild_raw.content)
				del f
			self.lastdata = str(login.text)
			self.msgCallback(['aktion', 'Captcha Eingabe'])
		else:
			self.msgCallback(['msg', 'Suche Alexa Geraete'])
			self.getDevice()

	def say(self, msg):
		if self.load_cookies() is not None:
			kekse = self.load_cookies()
			self.s.cookies.update(kekse)
			csrf = str(self.s.cookies.get_dict()['csrf'])
			self.s.headers.update({
									'csrf': csrf,
									'Host': 'alexa.amazon.de',
									'Origin': 'https://alexa.amazon.de',
									'Content-Type': 'application/json; charset=UTF-8',
									'Referer': 'https://alexa.amazon.de/spa/index.html',
									'Accept': '*/*'
								})

			data = {
					"behaviorId": "PREVIEW",
					"sequenceJson": "{\"@type\": \
					\"com.amazon.alexa.behaviors.model.Sequence\", \
					\"startNode\":{\"@type\": \
					\"com.amazon.alexa.behaviors.model.OpaquePayloadOperationNode\", \
					\"type\":\"Alexa.Speak\",\"operationPayload\": \
					{\"deviceType\":\"" + config.plugins.alexatts.deviceType.value + "\", \
					\"deviceSerialNumber\":\"" + config.plugins.alexatts.deviceSerialNumber.value +
					"\",\"locale\":\"en-US\", \
					\"customerId\":\"" + config.plugins.alexatts.customerId.value +
					"\", \"textToSpeak\": \"" + msg + "\"}}}",
					"status": "ENABLED"
				}
			post_login = self.s.post('https://alexa.amazon.de/api/behaviors/preview', data=json.dumps(data), allow_redirects=True)
			print "[Alexatts] Text gesendet:", post_login.status_code
			print post_login.text
		else:
			print "[Alexatts] Cookie datei fehlt"

	def save_cookies(self, kekse):
		with open(self.path+'alexa_cookies', 'wb') as f:
			json.dump(kekse, f)

	def load_cookies(self):
		if os.path.exists(self.path+'alexa_cookies'):
			with open(self.path+'alexa_cookies', 'rb') as f:
				data = json.load(f)
			return data
		else:
			return None

	def save_devices(self, devices):
		with open(self.path+'devices.json', 'w') as f:
			json.dump(devices, f)

	def load_devices(self):
		if os.path.exists(self.path+'devices.json'):
			with open(self.path+'devices.json') as f:
				data = json.load(f)
			return data
		else:
			return None