# -*- coding: utf-8 -*-
# by einfall for DreamOS

from Screens.MessageBox import MessageBox
from Screens.TextBox import TextBox
from Screens.ChoiceBox import ChoiceBox
from Screens.Screen import Screen
from Screens.Standby import inStandby
from Components.ActionMap import ActionMap, NumberActionMap
from Components.Sources.StaticText import StaticText
from Components.Sources.List import List
from Components.MenuList import MenuList
from Components.Label import Label
from Components.config import config, getConfigListEntry
from Components.ConfigList import ConfigListScreen
from Components.config import config, getConfigListEntry, ConfigSelection, ConfigText, ConfigClock, ConfigSubsection, ConfigYesNo, ConfigSubDict, ConfigNothing, ConfigInteger, configfile
from skin import loadSkin
from Tools.Directories import resolveFilename, SCOPE_PLUGINS, fileExists
from Tools.NumericalTextInput import NumericalTextInput
from enigma import gFont, addFont, eTimer, eConsoleAppContainer, ePicLoad, loadPNG, getDesktop, eServiceReference, iPlayableService, eListboxPythonMultiContent, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_CENTER, eListbox, gPixmapPtr, getPrevAsciiCode, eBackgroundFileEraser
from Plugins.Plugin import PluginDescriptor

from skin import TemplatedListFonts
sz_w = getDesktop(0).size().width()

from threading import Thread
import threading, re, os, requests, json, hashlib, sqlite3, socket, time

from datetime import datetime, timedelta

import NavigationInstance
from enigma import eServiceCenter, eServiceReference, eEPGCache
from RecordTimer import RecordTimerEntry, RecordTimer, parseEvent, AFTEREVENT
from ServiceReference import ServiceReference
from Components.ServiceEventTracker import ServiceEventTracker

from alexatts import alexatts
from VirtualKeyBoardCaptcha import *
alexatts_thread = None


config.plugins.alexatts = ConfigSubsection()
config.plugins.alexatts.user = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.password = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.name = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.deviceType = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.deviceSerialNumber = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.customerId = ConfigText(default="", fixed_size=False)
config.plugins.alexatts.timerange = ConfigYesNo(default = True)
config.plugins.alexatts.startzeit = ConfigClock(default=13 * 3600)
config.plugins.alexatts.endzeit = ConfigClock(default=13 * 3600)
config.plugins.alexatts.standby = ConfigYesNo(default = True)

## ttsTrigger
config.plugins.alexatts.recstart = ConfigYesNo(default = True)
config.plugins.alexatts.recend = ConfigYesNo(default = True)
config.plugins.alexatts.timeshift_start = ConfigYesNo(default = True)
config.plugins.alexatts.timeshift_end = ConfigYesNo(default = True)
config.plugins.alexatts.instandby = ConfigYesNo(default = True)
config.plugins.alexatts.instandby_text = ConfigText(default="Box wird ausgeschaltet", fixed_size=False)
config.plugins.alexatts.ausstandby = ConfigYesNo(default = True)
config.plugins.alexatts.ausstandby_text = ConfigText(default="Box wird eingeschaltet", fixed_size=False)
config.plugins.alexatts.tv_time = ConfigYesNo(default = True)
config.plugins.alexatts.event_new = ConfigYesNo(default = True)


class AlexattsMain(Screen):

	if sz_w == 1920:
		skin = """
		<screen name="AlexattsMain" position="center,170" size="1200,820" title="Alexa Text To Speech">
			<ePixmap position="1100,5" size="70,70" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="1180,70" font="Regular;30" halign="center" valign="center" />
			<eLabel	position="10,80" size="1180,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="list" position="10,90" scrollbarMode="showOnDemand" size="1180,630" itemHeight="90" />
			<eLabel	position="10,730" size="1180,1" backgroundColor="grey"/>
			<widget name="foot" position="10,740" size="1180,70" font="Regular;30" halign="center" valign="center" />
		</screen>"""
	else:
		skin = """
		<screen name="AlexattsMain" position="center,120" size="820,520" title="Alexa Text To Speech">
			<ePixmap position="750,10" size="50,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="800,60" font="Regular;24" halign="center" valign="center" />
			<eLabel	position="10,70" size="800,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="list" position="10,80" scrollbarMode="showOnDemand" size="800,350" itemHeight="70" />
			<eLabel	position="10,450" size="800,1" backgroundColor="grey"/>
			<widget name="foot" position="10,455" size="800,60" font="Regular;24" halign="center" valign="center" />
		</screen>"""

	def __init__(self, session):
		Screen.__init__(self, session)
		self['actions'] = ActionMap(['OkCancelActions', 'ColorActions', 'MenuActions'], {
		'ok': self.key_ok,
		'cancel': self.close
		})

		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		tlf = TemplatedListFonts()
		self.ml.l.setFont(0, gFont(tlf.face(tlf.BIG), tlf.size(tlf.BIG)))
		self['list'] = self.ml

		self['info'] = Label("Übersicht")
		self['foot'] = Label("")
		
		self.onLayoutFinish.append(self.buildList)

	def buildList(self):
		self.list = []
		self.list.append(("Alexa Geräte"))
		self.list.append(("Sprachausgabe"))
		self.list.append(("Einstellungen"))
		self.ml.setList(map(self.showListCenter, self.list))

	def showListCenter(self, entry):
		width = self['list'].instance.size().width()
		height = self['list'].l.getItemSize().height()
		res = [entry]
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, height, 0, RT_HALIGN_CENTER | RT_VALIGN_CENTER, entry))
		return res

	def key_ok(self):
		ok = self['list'].getCurrent()
		if ok and ok[0]:
			print ok[0]
			if ok[0] == "Alexa Geräte":
				self.session.open(AlexattsDevices)
			elif ok[0] == "Sprachausgabe":
				self.session.open(AlexattsSprachausgabe)
			elif ok[0] == "Einstellungen":
				self.session.open(AlexattsSetup)

	def key_close(self):
		self.close()

class AlexattsSprachausgabe(Screen, ConfigListScreen):

	if sz_w == 1920:
		skin = """
		<screen name="AlexattsSetup" position="center,170" size="1200,820" title="Alexa Text To Speech">
			<ePixmap position="1100,5" size="70,70" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="1180,70" font="Regular;30" halign="center" valign="center" />
			<eLabel	position="10,80" size="1180,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="config" position="10,90" scrollbarMode="showOnDemand" size="1180,630" />
			<eLabel	position="10,730" size="1180,1" backgroundColor="grey"/>
			<widget name="foot" position="10,740" size="1180,70" font="Regular;30" halign="center" valign="center" />
		</screen>"""
	else:
		skin = """
		<screen name="AlexattsSetup" position="center,120" size="820,520" title="Alexa Text To Speech">
			<ePixmap position="750,10" size="50,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="800,60" font="Regular;24" halign="center" valign="center" />
			<eLabel	position="10,70" size="800,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="config" position="10,80" scrollbarMode="showOnDemand" size="800,360" />
			<eLabel	position="10,450" size="800,1" backgroundColor="grey"/>
			<widget name="foot" position="10,455" size="800,60" font="Regular;24" halign="center" valign="center" />
		</screen>"""

	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"], {
			"cancel":	self.keyCancel,
			"red"	:	self.keyCancel,
			"green" :	self.keyGreen,
			"ok"	:	self.keyGreen,
			"info"	:	self.keyEPG
		}, -1)

		self['info'] = Label("Sprachausgabe bei:")
		self['foot'] = Label("")
		self.list = []
		self.createConfigList()
		self.alexa = alexatts(self.session)
		ConfigListScreen.__init__(self, self.list)

	def createConfigList(self):
		self.list = []
		self.list.append(getConfigListEntry(_("Sprachausgabe"), ))
		self.list.append(getConfigListEntry(_("Sprachausgabe nur wenn Box nicht im Standby ist"), config.plugins.alexatts.standby))
		self.list.append(getConfigListEntry(_("Zeitspanne"), config.plugins.alexatts.timerange))
		if config.plugins.alexatts.timerange.value:
			self.list.append(getConfigListEntry(_("Zeitspanne von"), config.plugins.alexatts.startzeit))
			self.list.append(getConfigListEntry(_("Zeitspanne bis"), config.plugins.alexatts.endzeit))
		self.list.append(getConfigListEntry(_("Aufnahme / Timeshift"), ))
		self.list.append(getConfigListEntry(_("Neue Sendung/Film beginnt"), config.plugins.alexatts.event_new))
		self.list.append(getConfigListEntry(_("Aufnahme gestartet"), config.plugins.alexatts.recstart))
		self.list.append(getConfigListEntry(_("Aufnahme beendet"), config.plugins.alexatts.recend))
		self.list.append(getConfigListEntry(_("Timeshift gestartet"), config.plugins.alexatts.timeshift_start))
		self.list.append(getConfigListEntry(_("Timeshift beendet"), config.plugins.alexatts.timeshift_end))
		self.list.append(getConfigListEntry(_("Standby"), ))
		self.list.append(getConfigListEntry(_("Box IN Standby"), config.plugins.alexatts.instandby))
		if config.plugins.alexatts.instandby.value:
			self.list.append(getConfigListEntry(_("TEXT"), config.plugins.alexatts.instandby_text))
		self.list.append(getConfigListEntry(_("Box AUS Standby"), config.plugins.alexatts.ausstandby))
		if config.plugins.alexatts.ausstandby.value:
			self.list.append(getConfigListEntry(_("TEXT"), config.plugins.alexatts.ausstandby_text))
		self.list.append(getConfigListEntry(_("Zeitansage wie lange die Box im Betrieb war (Box IN Standby)"), config.plugins.alexatts.tv_time))
		#self.list.append(getConfigListEntry(_("Fritzbox"), ))
		#self.list.append(getConfigListEntry(_("Fritzbox Sprachausgabe bei Anruf"), config.plugins.alexatts.fritz_cm))
		#if config.plugins.alexatts.fritz_cm.value:
		#	self.list.append(getConfigListEntry(_("Fritzbox IP:"), config.plugins.alexatts.fritz_ip))
		#	self.list.append(getConfigListEntry(_("Fritzbox User:"), config.plugins.alexatts.fritz_user))
		#	self.list.append(getConfigListEntry(_("Fritzbox Password:"), config.plugins.alexatts.fritz_pass))
		#	self.list.append(getConfigListEntry(_("Ortsansage bei Unbekannten Teilnehmer:"), config.plugins.alexatts.fritz_vorwahl))

	def changedEntry(self):
		self.createConfigList()
		self["config"].setList(self.list)

	def keyLeft(self):
		ConfigListScreen.keyLeft(self)
		self.changedEntry()

	def keyRight(self):
		ConfigListScreen.keyRight(self)
		self.changedEntry()

	def keyRed(self):
		self.close()

	def keyGreen(self):
		config.plugins.alexatts.standby.save()
		config.plugins.alexatts.timerange.save()
		config.plugins.alexatts.startzeit.save()
		config.plugins.alexatts.endzeit.save()
		config.plugins.alexatts.event_new.save()
		config.plugins.alexatts.recstart.save()
		config.plugins.alexatts.recend.save()
		config.plugins.alexatts.timeshift_start.save()
		config.plugins.alexatts.timeshift_end.save()
		config.plugins.alexatts.instandby.save()
		config.plugins.alexatts.instandby_text.save()
		config.plugins.alexatts.ausstandby.save()
		config.plugins.alexatts.ausstandby_text.save()
		config.plugins.alexatts.tv_time.save()
		#config.plugins.alexatts.fritz_cm.save()
		#config.plugins.alexatts.fritz_ip.save()
		#config.plugins.alexatts.fritz_user.save()
		#config.plugins.alexatts.fritz_pass.save()
		#config.plugins.alexatts.fritz_vorwahl.save()
		configfile.save()
		self.close()

	def keyEPG(self):
		pass

	def keyCancel(self):
		self.close()

class AlexattsDevices(Screen):

	if sz_w == 1920:
		skin = """
		<screen name="AlexattsDevices" position="center,170" size="1200,820" title="Alexa Text To Speech">
			<ePixmap position="1100,5" size="70,70" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="1180,70" font="Regular;30" halign="center" valign="center" />
			<eLabel	position="10,80" size="1180,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="list" position="10,90" scrollbarMode="showOnDemand" size="1180,630" />
			<eLabel	position="10,730" size="1180,1" backgroundColor="grey"/>
			<widget name="foot" position="10,740" size="1180,70" font="Regular;30" halign="center" valign="center" />
		</screen>"""
	else:
		skin = """
		<screen name="AlexattsDevices" position="center,120" size="820,520" title="Alexa Text To Speech">
			<ePixmap position="750,10" size="50,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="800,60" font="Regular;24" halign="center" valign="center" />
			<eLabel	position="10,70" size="800,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="list" position="10,80" scrollbarMode="showOnDemand" size="800,360" />
			<eLabel	position="10,450" size="800,1" backgroundColor="grey"/>
			<widget name="foot" position="10,455" size="800,60" font="Regular;24" halign="center" valign="center" />
		</screen>"""

	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"], {
			"cancel":	self.keyCancel,
			"red"	:	self.keyCancel,
			"ok"	:	self.keyOk
		}, -1)

		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		tlf = TemplatedListFonts()
		self.ml.l.setFont(0, gFont(tlf.face(tlf.MEDIUM), tlf.size(tlf.MEDIUM)))
		self['list'] = self.ml
		self.list = []

		self['info'] = Label("Alexa Geräte")
		self['foot'] = Label("- OK - zum auswählen")
		
		self.onLayoutFinish.append(self.genre)
		self.alexa = alexatts(self.session)

	def genre(self):
		self.list = []
		if self.alexa.load_devices() is not None:
			self.devices = self.alexa.load_devices()
			if self.devices:
				print self.devices
				for device in self.devices.keys():
					if str(device) == config.plugins.alexatts.name.value:
						self.list.append((str(device), True))
					else:
						self.list.append((str(device), False))
				self.ml.setList(map(self.showListMark, self.list))
		else:
			self.list.append(('Keine Geräte gefunden !', False))
			self.ml.setList(map(self.showListMark, self.list))

	def showListMark(self, entry):
		width = self['list'].instance.size().width()
		height = self['list'].l.getItemSize().height()
		res = [entry]
		if entry[1]:
			marked = "/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/mark.png"
			res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHATEST, 0, 0, 10, 40, loadPNG(marked)))
		res.append((eListboxPythonMultiContent.TYPE_TEXT, 30, 0, width, height, 0, RT_HALIGN_LEFT | RT_VALIGN_CENTER, entry[0]))
		return res

	def keyOk(self):
		exist = self['list'].getCurrent()
		if exist == None:
			return
		device = self['list'].getCurrent()[0][0]
		if device != 'Keine Geräte gefunden !':
			print "[Alexatts]", device
			deviceType = str(self.devices[''+str(device)+'']['deviceType'])
			serialNumber = str(self.devices[''+str(device)+'']['serialNumber'])
			deviceOwnerCustomerId = str(self.devices[''+str(device)+'']['deviceOwnerCustomerId'])

			config.plugins.alexatts.name.value = device
			config.plugins.alexatts.name.save()

			config.plugins.alexatts.deviceType.value = deviceType
			config.plugins.alexatts.deviceType.save()

			config.plugins.alexatts.deviceSerialNumber.value = serialNumber
			config.plugins.alexatts.deviceSerialNumber.save()

			config.plugins.alexatts.customerId.value = deviceOwnerCustomerId
			config.plugins.alexatts.customerId.save()

			configfile.save()
			self.alexa.say("Lautsprecher %s ausgewählt" % device)

	def keyCancel(self):
		self.close()

class AlexattsSetup(Screen, ConfigListScreen):

	if sz_w == 1920:
		skin = """
		<screen name="AlexattsSetup" position="center,170" size="1200,820" title="Alexa Text To Speech">
			<ePixmap position="1100,5" size="70,70" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="1180,70" font="Regular;30" halign="center" valign="center" />
			<eLabel	position="10,80" size="1180,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="config" position="10,90" scrollbarMode="showOnDemand" size="1180,630" />
			<eLabel	position="10,730" size="1180,1" backgroundColor="grey"/>
			<widget name="foot" position="10,740" size="1180,70" font="Regular;30" halign="center" valign="center" />
		</screen>"""
	else:
		skin = """
		<screen name="AlexattsSetup" position="center,120" size="820,520" title="Alexa Text To Speech">
			<ePixmap position="750,10" size="50,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/alexatts/pic/logo.png"/>
			<widget name="info" position="10,5" size="800,60" font="Regular;24" halign="center" valign="center" />
			<eLabel	position="10,70" size="800,1" backgroundColor="grey"/>
			<widget enableWrapAround="1" name="config" position="10,80" scrollbarMode="showOnDemand" size="800,360" />
			<eLabel	position="10,450" size="800,1" backgroundColor="grey"/>
			<widget name="foot" position="10,455" size="800,68" font="Regular;24" halign="center" valign="center" />
		</screen>"""

	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["actions"]  = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"], {
			"cancel":	self.keyCancel,
			"red"	:	self.keyCancel,
			"green" :	self.keyGreen,
			"ok"	:	self.keyGreen
			#"info"	:	self.keyInfo
		}, -1)

		self['info'] = Label("Einstellungen")
		self['foot'] = Label("- OK - für Login drücken")
		self.list = []
		self.createConfigList()
		self.alexa = alexatts(self.session)
		self.alexa.setCallback(self.msgCallback)
		ConfigListScreen.__init__(self, self.list)
		
		self["numberActions"] = NumberActionMap(["NumberActions"],
		{
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
			"0": self.keyNumberGlobal
		})

	#def keyInfo(self):
	#	self.session.openWithCallback(self.VirtualKeyBoardCallback, VirtualKeyBoardCaptcha, "Eingabe", "test", "https://bilder.wunschliste.de/sendung/hr/v22834.png")
			
	def keyNumberGlobal(self, input):
		from Screens.VirtualKeyBoard import VirtualKeyBoard
		self.session.openWithCallback(self.VirtualKeyBoardCallback, VirtualKeyBoard, "Eingabe", text = self["config"].getCurrent()[1].getValue())
		
	def VirtualKeyBoardCallback(self, callback = None):
		if callback is not None and len(callback):
			print "callback:", callback
			self["config"].getCurrent()[1].setValue(callback)
			self["config"].invalidate(self["config"].getCurrent())

	def msgCallback(self, txt):
		print "MMMMMMMMMSGGGGGGG:", txt
		(type, msg) = txt
		if type == 'msg':
			print msg
			self['foot'].setText(msg)
		else:
			self.session.openWithCallback(self.captcha_text, VirtualKeyBoardCaptcha, "Captcha Eingabe", "", "/tmp/alexa_captcha.jpg")

	def createConfigList(self):
		self.list = []
		self.list.append(getConfigListEntry(_("Login:"), ))
		self.list.append(getConfigListEntry(_("alexa.amazon.de Email:"), config.plugins.alexatts.user))
		self.list.append(getConfigListEntry(_("alexa.amazon.de Password:"), config.plugins.alexatts.password))

	def changedEntry(self):
		self.createConfigList()
		self["config"].setList(self.list)

	def keyLeft(self):
		ConfigListScreen.keyLeft(self)
		self.changedEntry()

	def keyRight(self):
		ConfigListScreen.keyRight(self)
		self.changedEntry()

	def keyRed(self):
		self.close()

	def keyGreen(self):
		config.plugins.alexatts.user.save()
		config.plugins.alexatts.password.save()
		configfile.save(),
		ok = self.alexa.login(config.plugins.alexatts.user.value, config.plugins.alexatts.password.value)
		print "[Alexatts] return:", ok

	def captcha_text(self, text):
		print "[Alexatts] Captcha Eingegeben:", text
		if text is not None:
			self.alexa.enterCaptcha(text, config.plugins.alexatts.user.value, config.plugins.alexatts.password.value)		

	def keyCancel(self):
		self.close()

class ttsTrigger():

	def __init__(self, session):
		self.session = session
		self.alexa = alexatts(self.session)
		self.start_time = int(time.time())
		self.end_time = 0
		self.session.nav.RecordTimer.on_state_change.append(self.onStateChange)
		config.misc.standbyCounter.addNotifier(self.standbyCounterChanged, initial_call = False)
		self.onClose = [ ]
		self.service_name_old = None
		self.event_name_old = None
		self.timeshiftEnabled = False
		self.__event_tracker = ServiceEventTracker(screen=self, eventmap=
			{
				iPlayableService.evUpdatedEventInfo: self.__eventInfoChanged_own,
				iPlayableService.evSeekableStatusChanged: self.__seekableStatusChanged_own
			})

# Speak
	def speak(self, msg, force=False):
		allowed = False
		if config.plugins.alexatts.standby.value:
			if not inStandby:
				allowed = True
			else:
				allowed = False
		else:
			allowed = True

		if config.plugins.alexatts.timerange.value:
			import datetime
			now = datetime.datetime.now()
			print now.hour, now.minute
			start = datetime.time(config.plugins.alexatts.startzeit.value[0], config.plugins.alexatts.startzeit.value[1], 0)
			end = datetime.time(config.plugins.alexatts.endzeit.value[0], config.plugins.alexatts.endzeit.value[1], 0)
			if self.time_in_range(start, end, datetime.time(now.hour, now.minute, 0)):
				allowed = True
			else:
				allowed = False
		else:
			allowed = True
		print "[Alexa TTS] allowed to speak:", allowed, msg

		if force:
			allowed = True
		if allowed:
			self.alexa.say(msg)

	def time_in_range(self, start, end, x):
		"""Return true if x is in the range [start, end]"""
		if start <= end:
			return start <= x <= end
		else:
			return start <= x or x <= end

# Recording		
	def onStateChange(self, timer):
		print '[Alexatts] Event:', timer.state
		print timer
		if timer.state == 2:
			if config.plugins.alexatts.recstart.value:
				self.speak("Aufnahme %s gestartet" % (timer.name))
		if timer.state == 3:
			if config.plugins.alexatts.recend.value:
				self.speak("Aufnahme %s beendet" % (timer.name))

# Timeshift
	def getTimeshift(self):
		print "getTimeshift-----------------------------"
		service = self.session.nav.getCurrentService()
		if service is not None:
			return service and service.timeshift()

	def __seekableStatusChanged_own(self):
		print "seekableStatusChanged_own-----------------------------"
		ts = self.getTimeshift()
		if ts is not None:
			if ts.isTimeshiftActive():
				if not self.timeshiftEnabled:
					print "[Alexatts] aktiviere timeshift"
					self.timeshiftEnabled = True
					if config.plugins.alexatts.timeshift_start.value:
						self.speak("Timeshift gestartet")
			else:
				if self.timeshiftEnabled:
					print "[Alexatts] beende timeshift"
					self.timeshiftEnabled = False
					if config.plugins.alexatts.timeshift_end.value:
						self.speak("Timeshift beendet")

# Standby
	def leaveStandby(self):
		self.start_time = int(time.time())
		if config.plugins.alexatts.ausstandby.value:
			self.speak("%s" % config.plugins.alexatts.ausstandby_text.value)

	def standbyCounterChanged(self, configElement):
		from Screens.Standby import inStandby
		inStandby.onClose.append(self.leaveStandby)
		self.end_time = int(time.time())
		if config.plugins.alexatts.instandby.value:
			self.speak("%s" % config.plugins.alexatts.instandby_text.value)
		if config.plugins.alexatts.tv_time.value:
			sekunden = (self.end_time-self.start_time)
			txt = self.zeitspanne(sekunden)
			self.speak("Der Fernseher war %s eingeschaltet" % txt)

	def zeitspanne(self, sekunden):
		delta = timedelta(seconds = sekunden)
		delta_str = str(delta)[-8:]
		hours, minutes, seconds = [ int(val) for val in delta_str.split(":", 3) ]
		weeks = delta.days // 7
		days = delta.days % 7
		zeit = []
		if weeks > 0:
			zeit.append('%s Wochen' % str(weeks))
		if days > 0:
			zeit.append('%s Tage' % str(days))
		if hours > 0:
			zeit.append('%s Stunden' % str(hours))
		if minutes > 0:
			zeit.append('%s Minuten' % str(minutes))
		if seconds > 0:
			zeit.append('%s Sekunden' % str(seconds))
		return ' und '.join(zeit)

# Now/Next
	def __eventInfoChanged_own(self):
		print "__eventInfoChanged_own-----------------------------"
		if config.plugins.alexatts.event_new.value:
			service = self.session.nav.getCurrentService()
			print "NOW NEXT CHANGED -------------------------------------------------------------------"
			if service and service is not None:
				info = service and service.info()
				service_name = service.info().getName()
				event = info and info.getEvent(0)
				if event is not None:
					event_name = event.getEventName()
					print "[Alexatts] NEW:", service_name, event_name
					print "[Alexatts] OLD:", self.service_name_old, self.event_name_old
					if self.service_name_old and self.event_name_old is not None:
						if service_name == self.service_name_old:
							if event_name != self.event_name_old:
								print "[Alexatts] Event Name CHANGED !!!!!!!! ---------------------------------------------"
								print "[Alexatts] SAGE: Sendung %s beginnt" % event_name
								self.event_name_old = event_name
								self.speak("Sendung %s beginnt" % event_name)
						else:
							self.service_name_old = service_name
							self.event_name_old = event_name
								
					else:
						self.service_name_old = service_name
						self.event_name_old = event_name
			else:
				print "NIX SERVICE REF -----------------------------------------------------------------"
		else:
			"NOW NEXT CHANGED DEAKTIVIERT -------------------------------------------------------------------"
		
def shutdown():
	global alexatts_thread
	if alexatts_thread is not None:
		alexatts_thread = None

def autostart(reason, **kwargs):
	if "session" in kwargs:
		session = kwargs["session"]
		global alexatts_thread
		alexatts_thread = Thread(target=ttsTrigger, args=(session,))
		alexatts_thread.daemon = True
		alexatts_thread.start()

def main(session, **kwargs):
	session.open(AlexattsMain)


def Plugins(path, **kwargs):
	list = []
	list.append(PluginDescriptor(where=[PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc=autostart, wakeupfnc=shutdown))
	list.append(PluginDescriptor(name = ("Alexa TTS"), description = ("Alexa Text to Speech"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc = main))
	return list